import 'package:vital_local_database/index.dart';

import 'syncable.dart';

/// 健康体检
class ExamEntity extends SyncableEntity<ExamEntity> {
  static const String _tableName = "exams";
  static final _columns = ExamColumnsDefine();

  // ignore: constant_identifier_names
  static const TABLE_CREATE_SQL = 'CREATE TABLE IF NOT EXISTS "$_tableName" ('
      '"id" INTEGER NOT NULL,'
      '"code" VARCHAR(100) NOT NULL,'
      '"userCode" VARCHAR(100) NOT NULL,'
      '"patientCode" VARCHAR(100) NOT NULL,'
      '"batchNumber" VARCHAR(100) NOT NULL,'
      '"templateKey" VARCHAR(100) NOT NULL,'
      '"dataJson" TEXT NOT NULL,'
      '"syncType" INTEGER NOT NULL,'
      '"syncState" INTEGER NOT NULL,'
      '"createTime" DATETIME NOT NULL,'
      '"updateTime" DATETIME NULL,'
      '"isValid" INTEGER NOT NULL,'
      'PRIMARY KEY ("id")'
      ');';

  @override
  IDbColumnsDefine<IDbEntity> get columns => _columns;

  @override
  String get tableName => _tableName;

  /// 居民档案编码
  String patientCode = '';

  /// 批次号
  String batchNumber = '';

  /// 模板Key
  String templateKey = '';
}

class ExamColumnsDefine extends SyncableColumnsDefine<ExamEntity>
    implements IDbColumnsDefine<ExamEntity> {
  /// 居民档案编码
  final patientCode = DbColumn<String>("patientCode");

  /// 批次号
  final batchNumber = DbColumn<String>("batchNumber");

  /// 模板Key
  final templateKey = DbColumn<String>("templateKey");
}
