import 'package:vital_local_database/core/interface/repository.dart';
import 'package:vitalapp/database/entities/patient.dart';

abstract class IPatientRepository
    implements IDbRepositroy<PatientEntity, PatientColumnsDefine> {
  /// 根据code获取实体
  Future<PatientEntity?> singleByCode(
    String code,
    String userCode,
  );

  /// 根据居民Code查找未上传数据列表
  ///
  /// [patientCode] 居民Code
  ///
  /// [syncState] 同步状态，不传搜索全部
  Future<bool> isNotUploadedPatient(
    String code,
    String userCode,
  );

  /// 增加随访数量
  Future<bool> increaseFollowUpCount(String code, String userCode);

  /// 增加体检数量
  Future<bool> increaseExamCount(String code, String userCode);

  /// 增加检测数量
  Future<bool> increaseDiagnoissCount(String code, String userCode);

  /// 减少随访数量
  Future<bool> decreaseFollowUpCount(String code, String userCode);

  /// 减少体检数量
  Future<bool> decreaseExamCount(String code, String userCode);

  /// 减少检测数量
  Future<bool> decreaseDiagnoissCount(String code, String userCode);
}
